#include <stdbool.h>
#include <smp.h>
#include <klog.h>
#include <printf.h>
#include <paging.h>
#include <video.h>
#include <acpi.h>
#include <panic.h>
#include <addr.h>
#include <stdbool.h>
#include <int.h>
#include <io.h>
#include <cpuid.h>
#include <heap.h>
#include <random.h>
#include <timer.h>
#include <libc.h>

//testing headers
#include <testmalloc.h>

void kmain() {
  PANIC(KERNEL_PANIC_KERNEL_RETURNED);
}

void smp_kinit() {
  printf("\nKernal started on core\n"); //TODO get lapic working, then print core number
  kmain();
}

//TODO move to global constructors
void kernel_init() {
  size_t pmap_size; 

  get_mem_capabilities(); 
  pmap_size = map_complete_physical();
  init_klog();
  init_pmap(pmap_size); 
  printf("\nKernal started on CPU 1!\n");
 
  
  find_root_sdp();
  debug_acpi();
  
  init_interrupts_bsp();

  
  randinit();

  smp_boot();
  fix_stack();
  //unmap_lowmem();
  kmain();
}
